#!/usr/bin/python
# ----------------------------------------------------------------------
# Generate a planar graph with network nodes, in each ring, randomly choose
# 2 nodes as working and backup node, and then add 1 gateway node, use Matlab 
# and delaunay() function to plot a planar graph with these nodes.
#
#         
# ----------------------------------------------------------------------
# input:
#       AG_to_ring.csv              association of ring number and the aggregation nodes it contains
#       corecoordinate.csv          association of aggregation node number and its center BS number
#       location.csv                association of BS number and its geographical coordinate
#       planar_info.csv             planar graph information generated by Matlab
# output:
#       planar_graph            planar graph edges information 
#       position_file.pkl       nodes geographical location information
#       color_list.pkl          node color information
#       position_info.csv       node name and its geographical location information

import csv
import sys
import time
import copy
import random
import math
import numpy as np
import scipy.io as sio
import networkx as nx
import matplotlib.pyplot as plt
import pickle
import pandas
import os

from os.path import expanduser
home = expanduser("~")
sys.path.append(home+'/git-projects/metro-haul-network-planning/backend/machine-learning-module/')
from params import *


def readcsv(filename):
    """
    read a csv file and save data in a 2 dimension array
    """
    size_row = 0
    size_col = 0
    for row in open(filename):
        size_row = size_row+1
        column = row.split(',')
        size_col = len(column)
                
    data = np.zeros((size_row, size_col))
    row_num = 0
    for row in open(filename):
        column = row.split(',')
        for i in range(0, size_col):
            if column[i] == '':
                column[i] = 0
            column[i] = float(column[i])      
        data[row_num] = column
        row_num = row_num+1

    return data, size_row, size_col


def writecsv(data, outputname):
    """
    write data into a csv file
    """
    csvfile = file(outputname, 'wb')
    writer = csv.writer(csvfile)
    writer.writerows(data)
    csvfile.close()


def main():
    input_file_1 = PATH_FOLDER_SOURCE_DATA+'topology.xlsx'
    df_nodes = pandas.read_excel(input_file_1, sheet_name='Nodes')
    df_fibers = pandas.read_excel(input_file_1, sheet_name='Fibers')
    df_wavranges=df_fibers['Slot Ranges']


    # input_file_2 = PATH_FOLDER_SOURCE_DATA+'example7nodes_withTraffic.n2p'
    
    # Computation of the planar_graph
    graph_node = {}
    pos = {}

    for key in df_nodes['Name'].keys():
        if df_nodes['Name'][key] == 'S_Node_BB_001':
            graph_node['gw1'] = {}
            graph_node['gw1']['location'] = [df_nodes['Longitude'][key], df_nodes['Latitude'][key]]

        graph_node[str(float(key))+'w'] = {}
        graph_node[str(float(key))+'w']['location'] = [df_nodes['Longitude'][key], df_nodes['Latitude'][key]]
        graph_node[str(float(key))+'b'] = {}
        graph_node[str(float(key))+'b']['location'] = [df_nodes['Longitude'][key], df_nodes['Latitude'][key]]

    pos = {}
    for node in graph_node:
        pos[node] = graph_node[node]['location']

    G = nx.DiGraph()
    G.add_nodes_from(pos.keys())

    # define number of gateway nodes and add them on the graph
    gw_list = ['gw1']
    # G.add_nodes_from(gw_list)
    # pos['gw1'] = [-3, 42] # Central Office  
    # ---------------------------------------------------------
    color_list = []
    for label in G.nodes():
        if label in gw_list:
            color_list.append('b')
        else:
            color_list.append('r')

    pos_list = []
    pos_name = []
    for key in pos.keys():
        pos_list.append([key] + pos[key])
    pos_list = np.array(pos_list)


    for key in df_fibers['Origin'].keys():

        if df_fibers['Origin'][key] == 'S_Node_BB_001':
            node_src = 'gw1'
            node_dst = df_nodes[df_nodes['Name'] == str(df_fibers['Destination'][key])].index.values.astype(float)[0]
            G.add_edge(str(node_src), str(node_dst)+'w')
            G.add_edge(str(node_dst)+'w', str(node_src))
            G.add_edge(str(node_src), str(node_dst)+'b')
            G.add_edge(str(node_dst)+'b', str(node_src))    

        elif df_fibers['Destination'][key] == 'S_Node_BB_001':
            node_src = df_nodes[df_nodes['Name'] == str(df_fibers['Origin'][key])].index.values.astype(float)[0]
            node_dst = 'gw1'
            G.add_edge(str(node_src)+'w', str(node_dst))
            G.add_edge(str(node_dst), str(node_src)+'w')
            G.add_edge(str(node_src)+'b', str(node_dst))
            G.add_edge(str(node_dst), str(node_src)+'b')    

        else:

            node_src = df_nodes[df_nodes['Name'] == str(df_fibers['Origin'][key])].index.values.astype(float)[0]
            node_dst = df_nodes[df_nodes['Name'] == str(df_fibers['Destination'][key])].index.values.astype(float)[0]
            G.add_edge(str(node_src)+'w', str(node_dst)+'w')
            G.add_edge(str(node_dst)+'w', str(node_src)+'w')
            G.add_edge(str(node_src)+'b', str(node_dst)+'b')
            G.add_edge(str(node_dst)+'b', str(node_src)+'b')    
            G.add_edge(str(node_src)+'w', str(node_src)+'b')
            G.add_edge(str(node_src)+'b', str(node_src)+'w')
            G.add_edge(str(node_dst)+'w', str(node_dst)+'b')
            G.add_edge(str(node_dst)+'b', str(node_dst)+'w')

   

    nx.write_edgelist(G, PATH_FOLDER_GENERATED_DATA+'planar_graph')
    pickle.dump(pos, open(PATH_FOLDER_GENERATED_DATA+'position_file.pkl','wb'))
    pickle.dump(color_list, open(PATH_FOLDER_GENERATED_DATA+'color_list.pkl', 'wb'))
    pickle.dump(color_list, open(PATH_FOLDER_GENERATED_DATA+'color_list_final.pkl', 'wb'))
        
#----------Dimensioning results--------------------------------------------
    graph_node_2 = {}
    for key in df_fibers['Origin'].keys():
        
        wav_ranges = df_fibers['Slot Ranges'][key].split(',')
        num_wav = float(wav_ranges[1])-float(wav_ranges[0])

        if df_fibers['Origin'][key] == 'S_Node_BB_001':
            node_src = 'gw1'
            node_dst = df_nodes[df_nodes['Name'] == str(df_fibers['Destination'][key])].index.values.astype(float)[0]

            graph_node_2[str(node_src), str(node_dst)+'w'] = {}
            graph_node_2[str(node_src), str(node_dst)+'w']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src), str(node_dst)+'w']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst)+'w', str(node_src)] = {}
            graph_node_2[str(node_dst)+'w', str(node_src)]['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst)+'w', str(node_src)]['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_src), str(node_dst)+'b'] = {}
            graph_node_2[str(node_src), str(node_dst)+'b']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src), str(node_dst)+'b']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst)+'b', str(node_src)] = {}
            graph_node_2[str(node_dst)+'b', str(node_src)]['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst)+'b', str(node_src)]['fibers'] = float(NUM_OF_FIBER)

        elif df_fibers['Destination'][key] == 'S_Node_BB_001':
            node_src = df_nodes[df_nodes['Name'] == str(df_fibers['Origin'][key])].index.values.astype(float)[0]
            node_dst = 'gw1'

            graph_node_2[str(node_src)+'w', str(node_dst)] = {}
            graph_node_2[str(node_src)+'w', str(node_dst)]['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src)+'w', str(node_dst)]['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst), str(node_src)+'w'] = {}
            graph_node_2[str(node_dst), str(node_src)+'w']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst), str(node_src)+'w']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_src)+'b', str(node_dst)] = {}
            graph_node_2[str(node_src)+'b', str(node_dst)]['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src)+'b', str(node_dst)]['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst), str(node_src)+'b'] = {}
            graph_node_2[str(node_dst), str(node_src)+'b']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst), str(node_src)+'b']['fibers'] = float(NUM_OF_FIBER)

        else:

            node_src = df_nodes[df_nodes['Name'] == str(df_fibers['Origin'][key])].index.values.astype(float)[0]
            node_dst = df_nodes[df_nodes['Name'] == str(df_fibers['Destination'][key])].index.values.astype(float)[0]
            
            graph_node_2[str(node_src)+'w', str(node_dst)+'w'] = {}
            graph_node_2[str(node_src)+'w', str(node_dst)+'w']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src)+'w', str(node_dst)+'w']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst)+'w', str(node_src)+'w'] = {}
            graph_node_2[str(node_dst)+'w', str(node_src)+'w']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst)+'w', str(node_src)+'w']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_src)+'b', str(node_dst)+'b'] = {}
            graph_node_2[str(node_src)+'b', str(node_dst)+'b']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src)+'b', str(node_dst)+'b']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst)+'b', str(node_src)+'b'] = {}
            graph_node_2[str(node_dst)+'b', str(node_src)+'b']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst)+'b', str(node_src)+'b']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_src)+'w', str(node_src)+'b'] = {}
            graph_node_2[str(node_src)+'w', str(node_src)+'b']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src)+'w', str(node_src)+'b']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_src)+'b', str(node_src)+'w'] = {}
            graph_node_2[str(node_src)+'b', str(node_src)+'w']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_src)+'b', str(node_src)+'w']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst)+'w', str(node_dst)+'b'] = {}
            graph_node_2[str(node_dst)+'w', str(node_dst)+'b']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst)+'w', str(node_dst)+'b']['fibers'] = float(NUM_OF_FIBER)

            graph_node_2[str(node_dst)+'b', str(node_dst)+'w'] = {}
            graph_node_2[str(node_dst)+'b', str(node_dst)+'w']['wavelengths'] = float(num_wav)
            graph_node_2[str(node_dst)+'b', str(node_dst)+'w']['fibers'] = float(NUM_OF_FIBER)


    pickle.dump(graph_node_2, open(PATH_FOLDER_GENERATED_DATA+'dimensioning_results.pkl','wb'))


#----------Network after dimensioning--------------------------------------------
    G_2 = nx.DiGraph()
    G_2.add_nodes_from(pos.keys())
    # G_2.add_nodes_from(gw_list)

    for key in df_fibers['Origin'].keys():

        if df_fibers['Origin'][key] == 'S_Node_BB_001':
            node_src = 'gw1'
            node_dst = df_nodes[df_nodes['Name'] == str(df_fibers['Destination'][key])].index.values.astype(float)[0]
            G_2.add_edge(str(node_src), str(node_dst)+'w')
            G_2.add_edge(str(node_dst)+'w', str(node_src))
            G_2.add_edge(str(node_src), str(node_dst)+'b')
            G_2.add_edge(str(node_dst)+'b', str(node_src)) 

        elif df_fibers['Destination'][key] == 'S_Node_BB_001':
            node_src = df_nodes[df_nodes['Name'] == str(df_fibers['Origin'][key])].index.values.astype(float)[0]
            node_dst = 'gw1'
            G_2.add_edge(str(node_src)+'w', str(node_dst))
            G_2.add_edge(str(node_dst), str(node_src)+'w')
            G_2.add_edge(str(node_src)+'b', str(node_dst))
            G_2.add_edge(str(node_dst), str(node_src)+'b')   

        else:
            node_src = df_nodes[df_nodes['Name'] == str(df_fibers['Origin'][key])].index.values.astype(float)[0]
            node_dst = df_nodes[df_nodes['Name'] == str(df_fibers['Destination'][key])].index.values.astype(float)[0]
            
            G_2.add_edge(str(node_src)+'w', str(node_dst)+'w')
            G_2.add_edge(str(node_dst)+'w', str(node_src)+'w')
            G_2.add_edge(str(node_src)+'b', str(node_dst)+'b')
            G_2.add_edge(str(node_dst)+'b', str(node_src)+'b')   
            G_2.add_edge(str(node_src)+'w', str(node_src)+'b')
            G_2.add_edge(str(node_src)+'b', str(node_src)+'w')
            G_2.add_edge(str(node_dst)+'w', str(node_dst)+'b') 
            G_2.add_edge(str(node_dst)+'b', str(node_dst)+'w')


    for (p, q) in G_2.edges():
        # print p, q
        G_2[p][q]['fiber'] = 1.0
        G_2[q][p]['fiber'] = 1.0

    nx.write_edgelist(G_2, PATH_FOLDER_GENERATED_DATA+'network_after_dimensioning')
 

if __name__ == '__main__':

    main()
